name: Unit tests

on: [push, pull_request]

jobs:
  run:
    if: ${{ !startsWith(github.event.head_commit.message, 'Translation:') }}
    runs-on: ${{ matrix.operating-system }}
    name: Testing PHP ${{ matrix.php-version }} on ${{ matrix.operating-system }}

    strategy:
      matrix:
        operating-system: [ubuntu-latest]
        php-version: ['8.1', '8.2', '8.3', '8.4']

    steps:
      - uses: shivammathur/setup-php@master
        with:
          php-version: ${{ matrix.php-version }}
          extensions: gd,intl,mbstring,sqlite,zip
          coverage: pcov

      - uses: actions/checkout@v3

      - run: composer validate

      - run: composer install --no-progress

      - run: vendor/bin/phpunit --coverage-clover=tests/coverage.xml

      - uses: codecov/codecov-action@v3
        with:
          token: ${{ secrets.CODECOV_TOKEN }}
          file: tests/coverage.xml
